    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.io.ByteArrayOutputStream

    java.lang.Object
       |
       +----java.io.OutputStream
               |
               +----java.io.ByteArrayOutputStream

public class ByteArrayOutputStream
extends OutputStream

This class implements an output stream in which the data is written into a byte array. The buffer automatically grows as data is written to it. The data can be retrieved using `toByteArray()` and `toString()`.

##

buf
  The buffer where data is stored.
count
  The number of valid bytes in the buffer.

##

ByteArrayOutputStream()
  Creates a new byte array output stream.
ByteArrayOutputStream(int)
  Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

##

reset()
  Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the ouput stream is discarded.
size()
  Returns the current size of the buffer.
toByteArray()
  Creates a newly allocated byte array.
toString()
  Converts the buffer's contents into a string, translating bytes into characters according to the platform's default character encoding.
toString(int)
  Creates a newly allocated string. Deprecated.
toString(String)
  Converts the buffer's contents into a string, translating bytes into characters according to the specified character encoding.
write(byte[], int, int)
  Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.
write(int)
  Writes the specified byte to this byte array output stream.
writeTo(OutputStream)
  Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.

##

buf

     protected byte buf[]

  The buffer where data is stored.

count

     protected int count

  The number of valid bytes in the buffer.

##

ByteArrayOutputStream

     public ByteArrayOutputStream()

  Creates a new byte array output stream. The buffer capacity is initially 32 bytes, though its size increases if necessary.

ByteArrayOutputStream

     public ByteArrayOutputStream(int size)

  Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

  Parameters:
    size - the initial size.

##

write

     public synchronized void write(int b)

  Writes the specified byte to this byte array output stream.

  Parameters:
    b - the byte to be written.
  Overrides:
    write in class OutputStream

write

     public synchronized void write(byte b[],
                                    int off,
                                    int len)

  Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.

  Parameters:
    b - the data.
    off - the start offset in the data.
    len - the number of bytes to write.
  Overrides:
    write in class OutputStream

writeTo

     public synchronized void writeTo(OutputStream out) throws IOException

  Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.

  Parameters:
    out - the output stream to which to write the data.
  Throws: IOException
    if an I/O error occurs.

reset

     public synchronized void reset()

  Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the ouput stream is discarded. The output stream can be used again, reusing the already allocated buffer space.

  See Also:
    count

toByteArray

     public synchronized byte[] toByteArray()

  Creates a newly allocated byte array. Its size is the current size of this output stream and the valid contents of the buffer have been copied into it.

  Returns:
    the current contents of this output stream, as a byte array.
  See Also:
    size

size

     public int size()

  Returns the current size of the buffer.

  Returns:
    the value of the `count` field, which is the number of valid bytes in this output stream.
  See Also:
    count

toString

     public String toString()

  Converts the buffer's contents into a string, translating bytes into characters according to the platform's default character encoding.

  Overrides:
    toString in class Object

toString

     public String toString(String enc) throws UnsupportedEncodingException

  Converts the buffer's contents into a string, translating bytes into characters according to the specified character encoding.

  Parameters:
    enc - a character-encoding name.

toString

     public String toString(int hibyte)

  Note: toString() is deprecated. This method does not properly convert bytes into characters. As of JDK 1.1, the preferred way to do this is via the `toString(String enc)` method, which takes an encoding-name argument, or the `toString()` method, which uses the platform's default character encoding.

  Creates a newly allocated string. Its size is the current size of the output stream and the valid contents of the buffer have been copied into it. Each character c in the resulting string is constructed from the corresponding element b in the byte array such that:
  `c == (char)(((hibyte & 0xff) << 8) | (b & 0xff))`

  Parameters:
    hibyte - the high byte of each resulting Unicode character.
  Returns:
    the current contents of the output stream, as a string.
  See Also:
    size, toString, toString

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.